<?php

namespace FiloBlu\Cegid\Plugin\Block\Checkout;

use Closure;
use FiloBlu\Cegid\Controller\Seller\Search;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Store\Model\ScopeInterface;

/**
 * Class LayoutProcessor
 * @see https://devdocs.magento.com/guides/v2.3/howdoi/checkout/checkout_customize.html#remove-a-component
 * @package FiloBlu\Cegid\Plugin\Block\Checkout
 */
class LayoutProcessor
{

    /**
     * @var ScopeConfigInterface
     */
    protected $scopeConfig;

    /**
     * LayoutProcessor constructor.
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(ScopeConfigInterface $scopeConfig) {
        $this->scopeConfig = $scopeConfig;
    }

    /**
     * @param \Magento\Checkout\Block\Checkout\LayoutProcessor $subject
     * @param Closure $proceed
     * @param $jsLayout
     * @return mixed
     */
    public function aroundProcess(\Magento\Checkout\Block\Checkout\LayoutProcessor $subject, Closure $proceed, $jsLayout)
    {
        $processedJsLayout = $proceed($jsLayout);

        if ($this->scopeConfig->isSetFlag(Search::XML_PATH_ENABLED, ScopeInterface::SCOPE_STORE)) {
            return $processedJsLayout;
        }

        unset(
            $processedJsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']['cegid-form-container']
        );

        return $processedJsLayout;
    }

}